OGRE: Ogre::ManualObject Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::ManualObject Class Reference
Core » Scene

Class providing a much simplified interface to generating manual objects with custom geometry. More...

`#include <OgreManualObject.h>`

Inheritance diagram for Ogre::ManualObject:
[legend]

## Classes
class | ManualObjectSection
| Built, renderable section of geometry. More...

## Public Types
typedef std::vector< ManualObjectSection * > | SectionList
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator

## Public Member Functions
| ManualObject (const String &name)
virtual | ~ManualObject ()
void | _releaseManualHardwareResources () override
| Notifies the movable object that hardware resources were lost.
void | _updateRenderQueue (RenderQueue *queue) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
virtual void | begin (const MaterialPtr &mat, RenderOperation::OperationType opType=RenderOperation::OT_TRIANGLE_LIST)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual void | begin (const String &materialName, RenderOperation::OperationType opType=RenderOperation::OT_TRIANGLE_LIST, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Start defining a part of the object.
virtual void | beginUpdate (size_t sectionIndex)
| Start the definition of an update to a part of the object.
void | clear (void)
| Completely clear the contents of the object.
void | colour (const ColourValue &col)
| Add a vertex colour to a vertex.
void | colour (float r, float g, float b, float a=1.0f)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual MeshPtr | convertToMesh (const String &meshName, const String &groupName=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Convert this object to a Mesh.
virtual ManualObjectSection * | end (void)
| Finish defining the object and compile the final renderable version.
virtual void | estimateIndexCount (uint32 icount)
| Estimate the number of indices ahead of time.
virtual void | estimateVertexCount (uint32 vcount)
| Estimate the number of vertices ahead of time.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
virtual size_t | getCurrentIndexCount () const
| Get the number of indices in the section currently being defined (returns 0 if no section is in progress).
virtual size_t | getCurrentVertexCount () const
| Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).
bool | getDynamic () const
| Gets whether this object is marked as dynamic.
EdgeData * | getEdgeList (void) override
| Implement this method to enable stencil shadows.
bool | getKeepDeclarationOrder () const
| Gets whether or not the declaration order is to be kept or not.
const String & | getMovableType (void) const override
| Returns the type name of this object.
size_t | getNumSections (void) const
ManualObjectSection * | getSection (size_t index) const
const std::vector< ManualObjectSection * > & | getSections () const
| Gets the list of ManualObjectSection, i.e.
const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDist, int flags=0) override
| Implement this method to enable stencil shadows.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
void | index (uint32 idx)
| Add a vertex index to construct faces / lines / points via indexing rather than just by a simple list of vertices.
void | normal (const Vector3 &norm)
| Add a vertex normal to the current vertex.
void | normal (float x, float y, float z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | position (const Vector3 &pos)
| Add a vertex position, starting a new vertex at the same time.
void | position (float x, float y, float z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | quad (uint32 i1, uint32 i2, uint32 i3, uint32 i4)
| Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.
void | setBoundingBox (const AxisAlignedBox &box)
| Sets the bounding box.
void | setBufferUsage (HardwareBuffer::Usage usage)
| Use before defining geometry to indicate how you intend to update the geometry.
void | setDynamic (bool dyn)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setKeepDeclarationOrder (bool keepOrder)
| Sets whether or not to keep the original declaration order when queuing the renderables.
void | setMaterial (size_t subIndex, const MaterialPtr &mat)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | setMaterialName (size_t subIndex, const String &name, const String &group=ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME)
| Alter the material for a subsection of this object after it has been specified.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | tangent (const Vector3 &tan)
| Add a vertex tangent to the current vertex.
void | tangent (float x, float y, float z)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | textureCoord (const Vector2 &uv)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | textureCoord (const Vector3 &uvw)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | textureCoord (const Vector4 &xyzw)
| @overload
void | textureCoord (float u)
| Add a texture coordinate to the current vertex.
void | textureCoord (float u, float v)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | textureCoord (float u, float v, float w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | textureCoord (float x, float y, float z, float w)
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
void | triangle (uint32 i1, uint32 i2, uint32 i3)
| Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

Class providing a much simplified interface to generating manual objects with custom geometry.

Building one-off geometry objects manually usually requires getting down and dirty with the vertex buffer and vertex declaration API, which some people find a steep learning curve. This class gives you a simpler interface specifically for the purpose of building a 3D object simply and quickly. Note that if you intend to instance your object you will still need to become familiar with the Mesh class.

This class draws heavily on the interface for OpenGL immediate-mode (`glBegin`, `glVertex`, `glNormal` etc), since this is generally well-liked by people. There are a couple of differences in the results though - internally this class still builds hardware buffers which can be re-used, so you can render the resulting object multiple times without re-issuing all the same commands again. Secondly, the rendering is not immediate, it is still queued just like all OGRE objects. This makes this object more efficient than the equivalent GL immediate-mode commands, so it's feasible to use it for large objects if you really want to.

To construct some geometry with this object:

1. If you know roughly how many vertices (and indices, if you use them) you're going to submit, call estimateVertexCount() and estimateIndexCount(). This is not essential but will make the process more efficient by saving memory reallocations.
2. Call begin() to begin entering data
3. For each vertex, call position(), normal(), textureCoord(), colour() to define your vertex data. Note that each time you call position() you start a new vertex. Note that the first vertex defines the components of the vertex - you can't add more after that. For example if you didn't call normal() in the first vertex, you cannot call it in any others. You ought to call the same combination of methods per vertex.
4. If you want to define triangles (or lines/points) by indexing into the vertex list, you can call index() as many times as you need to define them. If you don't do this, the class will assume you want triangles drawn directly as defined by the vertex list, i.e. non-indexed geometry. Note that stencil shadows are only supported on indexed geometry, and that indexed geometry is a little faster; so you should try to use it.
5. Call end() to finish entering data.
6. Optionally repeat the begin-end cycle if you want more geometry using different rendering operation types, or different materials After calling end(), the class will organise the data for that section internally and make it ready to render with. Like any other MovableObject you should attach the object to a SceneNode to make it visible. Other aspects like the relative render order can be controlled using standard MovableObject methods like setRenderQueueGroup.

You can also use beginUpdate() to alter the geometry later on if you wish. If you do this, you should call setDynamic(true) before your first call to begin(), and also consider using estimateVertexCount() / estimateIndexCount() if your geometry is going to be growing, to avoid buffer recreation during growth.

Note
  like all OGRE geometry, triangles should be specified in anti-clockwise winding order (whether you're doing it with just vertices, or using indexes too). That is to say that the front of the face is the one where the vertices are listed in anti-clockwise order.

## Member Typedef Documentation

## ◆ SectionList

typedef std::vector<ManualObjectSection*> Ogre::ManualObject::SectionList

## Constructor & Destructor Documentation

## ◆ ManualObject()

Ogre::ManualObject::ManualObject | ( | const String & | name | ) |

Referenced by Ogre::ManualObject::ManualObjectSection::ManualObjectSection(), and Ogre::ManualObject::ManualObjectSection::ManualObjectSection().

## ◆ ~ManualObject()

virtual Ogre::ManualObject::~ManualObject | ( |  | ) |
| virtual

## Member Function Documentation

## ◆ _releaseManualHardwareResources()

void Ogre::ManualObject::_releaseManualHardwareResources | ( |  | ) |
| inlineoverridevirtual

Notifies the movable object that hardware resources were lost.

Called automatically by RenderSystem if hardware resources were lost and can not be restored using some internal mechanism. Among affected resources are nested shadow renderables, ManualObjects, etc.

Reimplemented from Ogre::MovableObject.

References clear().

## ◆ clear()

void Ogre::ManualObject::clear | ( | void |  | ) |

Completely clear the contents of the object.

Clearing the contents of this object and rebuilding from scratch is not the optimal way to manage dynamic vertex data, since the buffers are recreated. If you want to keep the same structure but update the content within that structure, use beginUpdate() instead of clear() begin(). However if you do want to modify the structure from time to time you can do so by clearing and re-specifying the data.

Referenced by _releaseManualHardwareResources().

## ◆ estimateVertexCount()

virtual void Ogre::ManualObject::estimateVertexCount | ( | uint32 | vcount | ) |
| virtual

Estimate the number of vertices ahead of time.

Calling this helps to avoid memory reallocation when you define vertices. Also very handy when using beginUpdate() to manage dynamic data - you can make the vertex buffers a little larger than their initial needs to allow for growth later with this method.

## ◆ estimateIndexCount()

virtual void Ogre::ManualObject::estimateIndexCount | ( | uint32 | icount | ) |
| virtual

Estimate the number of indices ahead of time.

Calling this helps to avoid memory reallocation when you define indices. Also very handy when using beginUpdate() to manage dynamic data - you can make the index buffer a little larger than the initial need to allow for growth later with this method.

## ◆ begin() [1/2]

virtual void Ogre::ManualObject::begin | ( | const String & | materialName,
|  | RenderOperation::OperationType | opType = RenderOperation::OT_TRIANGLE_LIST,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )
| virtual

Start defining a part of the object.

Each time you call this method, you start a new section of the object with its own material and potentially its own type of rendering operation (triangles, points or lines for example).

Parameters

  materialName | The name of the material to render this part of the object with.
  opType | The type of operation to use to render.
  groupName | The resource group of the material to render this part of the object with.

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME, and Ogre::RenderOperation::OT_TRIANGLE_LIST.

## ◆ begin() [2/2]

virtual void Ogre::ManualObject::begin | ( | const MaterialPtr & | mat,
|  | RenderOperation::OperationType | opType = RenderOperation::OT_TRIANGLE_LIST )
| virtual

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  mat | The material to render this part of the object with.
  opType | The type of operation to use to render.

References Ogre::RenderOperation::OT_TRIANGLE_LIST.

## ◆ setBufferUsage()

void Ogre::ManualObject::setBufferUsage | ( | HardwareBuffer::Usage | usage | ) |
| inline

Use before defining geometry to indicate how you intend to update the geometry.

## ◆ setDynamic()

void Ogre::ManualObject::setDynamic | ( | bool | dyn | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References Ogre::HBU_CPU_TO_GPU, and Ogre::HBU_GPU_ONLY.

## ◆ getDynamic()

bool Ogre::ManualObject::getDynamic | ( |  | ) | const
| inline

Gets whether this object is marked as dynamic.

References Ogre::HBU_CPU_ONLY.

## ◆ beginUpdate()

virtual void Ogre::ManualObject::beginUpdate | ( | size_t | sectionIndex | ) |
| virtual

Start the definition of an update to a part of the object.

Using this method, you can update an existing section of the object efficiently. You do not have the option of changing the operation type obviously, since it must match the one that was used before.

Note
  If your sections are changing size, particularly growing, use estimateVertexCount and estimateIndexCount to pre-size the buffers a little larger than the initial needs to avoid buffer reconstruction.

Parameters

  sectionIndex | The index of the section you want to update. The first call to begin() would have created section 0, the second section 1, etc.

## ◆ position() [1/2]

void Ogre::ManualObject::position | ( | const Vector3 & | pos | ) |
| inline

Add a vertex position, starting a new vertex at the same time.

Remarks
  A vertex position is slightly special among the other vertex data methods like normal() and textureCoord(), since calling it indicates the start of a new vertex. All other vertex data methods you call after this are assumed to be adding more information (like normals or texture coordinates) to the last vertex started with position().

References OgreAssert, Ogre::VES_POSITION, and Ogre::VET_FLOAT3.

Referenced by Ogre::Volume::MeshBuilder::addCubeToManualObject(), and visitRenderables().

## ◆ position() [2/2]

void Ogre::ManualObject::position | ( | float | x,
|  | float | y,
|  | float | z )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References position().

Referenced by position().

## ◆ normal() [1/2]

void Ogre::ManualObject::normal | ( | const Vector3 & | norm | ) |
| inline

Add a vertex normal to the current vertex.

Vertex normals are most often used for dynamic lighting, and their components should be normalised.

References OgreAssert, Ogre::VES_NORMAL, and Ogre::VET_FLOAT3.

Referenced by visitRenderables().

## ◆ normal() [2/2]

void Ogre::ManualObject::normal | ( | float | x,
|  | float | y,
|  | float | z )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References normal().

Referenced by normal().

## ◆ tangent() [1/2]

void Ogre::ManualObject::tangent | ( | const Vector3 & | tan | ) |
| inline

Add a vertex tangent to the current vertex.

Vertex tangents are most often used for dynamic lighting, and their components should be normalised. Also, using tangent() you enable VES_TANGENT vertex semantic, which is not supported on old non-SM2 cards.

References OgreAssert, Ogre::VES_TANGENT, and Ogre::VET_FLOAT3.

Referenced by visitRenderables().

## ◆ tangent() [2/2]

void Ogre::ManualObject::tangent | ( | float | x,
|  | float | y,
|  | float | z )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References tangent().

Referenced by tangent().

## ◆ textureCoord() [1/7]

void Ogre::ManualObject::textureCoord | ( | float | u | ) |
| inline

Add a texture coordinate to the current vertex.

You can call this method multiple times between position() calls to add multiple texture coordinates to a vertex. Each one can have between 1 and 3 dimensions, depending on your needs, although 2 is most common. There are several versions of this method for the variations in number of dimensions.

References OgreAssert, Ogre::VES_TEXTURE_COORDINATES, and Ogre::VET_FLOAT1.

## ◆ textureCoord() [2/7]

void Ogre::ManualObject::textureCoord | ( | float | u,
|  | float | v )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References OgreAssert, Ogre::VES_TEXTURE_COORDINATES, and Ogre::VET_FLOAT2.

## ◆ textureCoord() [3/7]

void Ogre::ManualObject::textureCoord | ( | float | u,
|  | float | v,
|  | float | w )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References OgreAssert, Ogre::VES_TEXTURE_COORDINATES, and Ogre::VET_FLOAT3.

## ◆ textureCoord() [4/7]

void Ogre::ManualObject::textureCoord | ( | float | x,
|  | float | y,
|  | float | z,
|  | float | w )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References textureCoord().

Referenced by textureCoord().

## ◆ textureCoord() [5/7]

void Ogre::ManualObject::textureCoord | ( | const Vector2 & | uv | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References textureCoord().

Referenced by textureCoord().

## ◆ textureCoord() [6/7]

void Ogre::ManualObject::textureCoord | ( | const Vector3 & | uvw | ) |
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References textureCoord().

Referenced by textureCoord().

## ◆ textureCoord() [7/7]

void Ogre::ManualObject::textureCoord | ( | const Vector4 & | xyzw | ) |
| inline

@overload

References OgreAssert, Ogre::VES_TEXTURE_COORDINATES, and Ogre::VET_FLOAT4.

## ◆ colour() [1/2]

void Ogre::ManualObject::colour | ( | const ColourValue & | col | ) |
| inline

Add a vertex colour to a vertex.

References OgreAssert, Ogre::VES_DIFFUSE, and Ogre::VET_COLOUR.

Referenced by visitRenderables().

## ◆ colour() [2/2]

void Ogre::ManualObject::colour | ( | float | r,
|  | float | g,
|  | float | b,
|  | float | a = 1.0f )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

References colour().

Referenced by colour().

## ◆ index()

void Ogre::ManualObject::index | ( | uint32 | idx | ) |
| inline

Add a vertex index to construct faces / lines / points via indexing rather than just by a simple list of vertices.

You will have to call this 3 times for each face for a triangle list, or use the alternative 3-parameter version. Other operation types require different numbers of indexes,

See also
  RenderOperation::OperationType.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  idx | A vertex index from 0 to 4294967295.

References Ogre::IndexData::indexCount, Ogre::RenderOperation::indexData, OgreAssert, and Ogre::RenderOperation::useIndexes.

Referenced by Ogre::Volume::MeshBuilder::addCubeToManualObject(), getSection(), and triangle().

## ◆ triangle()

void Ogre::ManualObject::triangle | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3 )
| inline

Add a set of 3 vertex indices to construct a triangle; this is a shortcut to calling index() 3 times.

It is only valid for triangle lists.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3 | 3 vertex indices from 0 to 4294967295 defining a face.

References index(), OgreAssert, and Ogre::RenderOperation::OT_TRIANGLE_LIST.

Referenced by quad().

## ◆ quad()

void Ogre::ManualObject::quad | ( | uint32 | i1,
|  | uint32 | i2,
|  | uint32 | i3,
|  | uint32 | i4 )
| inline

Add a set of 4 vertex indices to construct a quad (out of 2 triangles); this is a shortcut to calling index() 6 times, or triangle() twice.

It's only valid for triangle list operations.

Note
  32-bit indexes are not supported on all cards and will only be used when required, if an index is > 65535.

Parameters

  i1,i2,i3,i4 | 4 vertex indices from 0 to 4294967295 defining a quad.

References triangle().

## ◆ getCurrentVertexCount()

virtual size_t Ogre::ManualObject::getCurrentVertexCount | ( |  | ) | const
| virtual

Get the number of vertices in the section currently being defined (returns 0 if no section is in progress).

## ◆ getCurrentIndexCount()

virtual size_t Ogre::ManualObject::getCurrentIndexCount | ( |  | ) | const
| virtual

Get the number of indices in the section currently being defined (returns 0 if no section is in progress).

## ◆ end()

virtual ManualObjectSection * Ogre::ManualObject::end | ( | void |  | ) |
| virtual

Finish defining the object and compile the final renderable version.

Note
  Will return a pointer to the finished section or NULL if the section was discarded (i.e. has zero vertices/indices).

## ◆ setMaterialName()

void Ogre::ManualObject::setMaterialName | ( | size_t | subIndex,
|  | const String & | name,
|  | const String & | group = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )
| inline

Alter the material for a subsection of this object after it has been specified.

You specify the material to use on a section of this object during the call to begin(), however if you want to change the material afterwards you can do so by calling this method.

Parameters

  subIndex | The index of the subsection to alter
  name | The name of the new material to use
  group | The resource group of the new material to use

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ setMaterial()

void Ogre::ManualObject::setMaterial | ( | size_t | subIndex,
|  | const MaterialPtr & | mat )
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Parameters

  subIndex | The index of the subsection to alter
  mat | The new material to use

## ◆ convertToMesh()

virtual MeshPtr Ogre::ManualObject::convertToMesh | ( | const String & | meshName,
|  | const String & | groupName = ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME )
| virtual

Convert this object to a Mesh.

After you've finished building this object, you may convert it to a Mesh if you want in order to be able to create many instances of it in the world (via Entity). This is optional, since this instance can be directly attached to a SceneNode itself, but of course only one instance of it can exist that way.

Note
  Only objects which use indexed geometry may be converted to a mesh.

Parameters

  meshName | The name to give the mesh
  groupName | The resource group to create the mesh in

References Ogre::ResourceGroupManager::DEFAULT_RESOURCE_GROUP_NAME.

## ◆ setUseIdentityProjection()

void Ogre::ManualObject::setUseIdentityProjection | ( | bool | useIdentityProjection | ) |

Sets whether or not to use an 'identity' projection.

Usually ManualObjects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normally you don't need to change this. The default is false.

See also
  ManualObject::getUseIdentityProjection

## ◆ getUseIdentityProjection()

bool Ogre::ManualObject::getUseIdentityProjection | ( | void |  | ) | const
| inline

Returns whether or not to use an 'identity' projection.

Usually ManualObjects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normally you don't need to change this.

See also
  ManualObject::setUseIdentityProjection

## ◆ setUseIdentityView()

void Ogre::ManualObject::setUseIdentityView | ( | bool | useIdentityView | ) |

Sets whether or not to use an 'identity' view.

Usually ManualObjects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normally you don't need to change this. The default is false.

See also
  ManualObject::getUseIdentityView

## ◆ getUseIdentityView()

bool Ogre::ManualObject::getUseIdentityView | ( | void |  | ) | const
| inline

Returns whether or not to use an 'identity' view.

Usually ManualObjects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normally you don't need to change this.

See also
  ManualObject::setUseIdentityView

## ◆ setBoundingBox()

void Ogre::ManualObject::setBoundingBox | ( | const AxisAlignedBox & | box | ) |
| inline

Sets the bounding box.

Remarks
  Call this after having finished creating sections to modify the bounding box. E.g. if you're using ManualObject to create 2D overlays you can call things function to set an infinite bounding box so that the object always stays visible when attached.

See also
  ManualObject::setUseIdentityProjection, ManualObject::setUseIdentityView, AxisAlignedBox::setInfinite

## ◆ getSections()

const std::vector< ManualObjectSection * > & Ogre::ManualObject::getSections | ( |  | ) | const
| inline

Gets the list of ManualObjectSection, i.e.

a part of a ManualObject.

## ◆ getSection()

ManualObjectSection * Ogre::ManualObject::getSection | ( | size_t | index | ) | const
| inline

References index().

## ◆ getNumSections()

size_t Ogre::ManualObject::getNumSections | ( | void |  | ) | const
| inline

## ◆ setKeepDeclarationOrder()

void Ogre::ManualObject::setKeepDeclarationOrder | ( | bool | keepOrder | ) |
| inline

Sets whether or not to keep the original declaration order when queuing the renderables.

This overrides the default behavior of the rendering queue, specifically stating the desired order of rendering. Might result in a performance loss, but lets the user to have more direct control when creating geometry through this class.

Parameters

  keepOrder | Whether to keep the declaration order or not.

## ◆ getKeepDeclarationOrder()

bool Ogre::ManualObject::getKeepDeclarationOrder | ( |  | ) | const
| inline

Gets whether or not the declaration order is to be kept or not.

Returns
  A flag indication if the declaration order will be kept when queuing the renderables.

## ◆ getMovableType()

const String & Ogre::ManualObject::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::ManualObject::getBoundingBox | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implements Ogre::MovableObject.

## ◆ getBoundingRadius()

Real Ogre::ManualObject::getBoundingRadius | ( | void |  | ) | const
| inlineoverridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ _updateRenderQueue()

void Ogre::ManualObject::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

## ◆ getEdgeList()

EdgeData * Ogre::ManualObject::getEdgeList | ( | void |  | ) |
| overridevirtual

Implement this method to enable stencil shadows.

Reimplemented from Ogre::ShadowCaster.

## ◆ getShadowVolumeRenderableList()

const ShadowRenderableList & Ogre::ManualObject::getShadowVolumeRenderableList | ( | const Light * | light,
|  | const HardwareIndexBufferPtr & | indexBuffer,
|  | size_t & | indexBufferUsedSize,
|  | float | extrusionDist,
|  | int | flags = 0 )
| overridevirtual

Implement this method to enable stencil shadows.

Reimplemented from Ogre::ShadowCaster.

## ◆ visitRenderables()

void Ogre::ManualObject::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| overridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

References colour(), normal(), OGRE_MAX_TEXTURE_COORD_SETS, position(), and tangent().

The documentation for this class was generated from the following file:

- OgreManualObject.h